package org.greenstone.gsdl3.action;

import org.greenstone.gsdl3.core.ModuleInterface;
import org.greenstone.gsdl3.util.*;
// XML classes
import org.w3c.dom.Node; 
import org.w3c.dom.Document; 
import org.w3c.dom.Element; 

import java.util.HashMap;

public class AppletAction extends Action {
    

    public String process (Element message) {


	// find the stylesheet
	String stylesheet = GSFile.stylesheetFile(config_, "applet.xsl");

	if (stylesheet==null) {
	    return GSHTML.errorPage("applet stylesheet not found!");
	}

	Element request = (Element)message.getElementsByTagName("request").item(0);
	// the applet info is like a/d = applet/display
	String info = request.getAttribute("info");
	// remove the a/ bit
	info = GSPath.removeFirstLink(info);
	String request_type = GSPath.getFirstLink(info); // should be 'd' or 'r'
	if (!request_type.equals("d")&&!request_type.equals("r")) {
	    return GSHTML.errorPage("the sa arg to a=a should be d or r!!");
	}
	
	// get the collection and service param
	Element cgi_paramList = (Element)GSXML.getChildByTagName(request, "paramList");
	cgi_.toLong(cgi_paramList);
	HashMap params = GSXML.extractParams(cgi_paramList);

	String collection = (String)params.get("c");
	String service_name=(String)params.get("sn");
	service_name+= "Applet";
	
	String to=null;
	if (collection==null||collection.equals("") ) {
	    to = service_name;
	} else {
	    to = GSPath.appendLink(collection, service_name);
	}

	System.out.println("to="+to);


	if (request_type.equals("d")) {
	    // we are just displaying the applet - get the description from
	    // the service, and process using xslt

	    //build up the mr request
	
	    Element mr_message = doc_.createElement("message");
	    Element mr_request = doc_.createElement("request");
	    mr_message.appendChild(mr_request);
	    mr_request.setAttribute("type", "describe");
	    mr_request.setAttribute("to", to);
	    //mr_request.setAttribute("info", "appletInfo");
	    
	    Element mr_response = (Element)mr_.process(mr_message);
	    
	    System.out.println("applet mr response =");
	    System.out.println(converter_.getString(mr_response));
	    // create the return page tree
	    Element page = doc_.createElement("page");
	    page.setAttribute("lang", message.getAttribute("lang"));
	    // add the lang stuff from message
	    page.appendChild(doc_.importNode(GSXML.getChildByTagName(message, "translate"), true));
	    // add the config stuff from message
	    page.appendChild(doc_.importNode(GSXML.getChildByTagName(message, "config"), true));
	    
	    page.appendChild(doc_.importNode(request, true));
	    // add in the applet info
	    
	    //page.appendChild(doc_.importNode(GSXML.getNodeByPath(mr_response, "response/service/applet"), true));
	    page.appendChild(doc_.importNode(GSXML.getNodeByPath(mr_response, "response/service/applet"), true));
	    return transformer_.transform(stylesheet, page);
	}
	else if (request_type.equals("r")) {
	    // we are processing stuff for the applet send a message to the service, type="query", and take out the something element, and return that as our result - the applet must take xml

	    Element mr_message = doc_.createElement("message");
	    Element mr_request = doc_.createElement("request");
	    mr_message.appendChild(mr_request);
	    mr_request.setAttribute("type", "query");
	    mr_request.setAttribute("to", to);
	    
	    // just append the params for now
	    mr_request.appendChild(doc_.importNode(cgi_paramList, true));
	    
	    Element mr_response = (Element)mr_.process(mr_message);
	    System.out.println("applet query response:");
	    // dont need to create a page, just extract the info out.
	    System.out.println(converter_.getString(mr_response));
	    Element applet_info = (Element)GSXML.getNodeByPath(mr_response, "response/appletData").getFirstChild();
	    System.out.println("applet action: applet data =");
	    System.out.println(converter_.getString(applet_info));
	    return converter_.getString(applet_info);

	}
	else {
	    // should never get here
	    return GSHTML.errorPage("applet action, wrong subaction type");
	}
    }
}
