package org.greenstone.gsdl3.action;

import org.greenstone.gsdl3.core.ModuleInterface;
import org.greenstone.gsdl3.util.*;
// XML classes
import org.w3c.dom.Node; 
import org.w3c.dom.Document; 
import org.w3c.dom.Element; 

import java.util.HashMap;
public class ResourceAction extends Action {


    // could pass in action name, and have it dynamically decide the name
   
    public String process (Element message) {

	// find the stylesheet
	String stylesheet = GSFile.stylesheetFile(config_, "resource.xsl");

	if (stylesheet==null) {
	    return GSHTML.errorPage("resource stylesheet not found!");
	}

	// for now, info="r" eventually we may want to change to r/text r/assoc
	// or something
	Element request = (Element)message.getElementsByTagName("request").item(0);

	Element cgi_paramList = (Element)GSXML.getChildByTagName(request, "paramList");
	cgi_.toLong(cgi_paramList);
	HashMap params = GSXML.extractParams(cgi_paramList);

	String resource_name = (String)params.get("r");
	if (resource_name == null || resource_name.equals("")) {
	    // no doc to show
	    return GSHTML.errorPage("no resource specified");
	}
	
	
	// create the return page tree
	Element page = doc_.createElement("page");
	page.setAttribute("lang", message.getAttribute("lang"));
	// add the lang stuff from message
	page.appendChild(doc_.importNode(GSXML.getChildByTagName(message, "translate"), true));
	// add the config stuff from message
	page.appendChild(doc_.importNode(GSXML.getChildByTagName(message, "config"), true));



	// build up the mr request
	Element mr_message = doc_.createElement("message");
	Element mr_request = doc_.createElement("request");
	mr_message.appendChild(mr_request);
	mr_request.setAttribute("type", "query");
	mr_request.setAttribute("resourceType", "core");
	String to = (String)params.get("c"); // collection name
	to = GSPath.appendLink(to, "ResourceRetrieve");
	mr_request.setAttribute("to", to);

	// all query requests must have a paramList and a content
	Element paramList = doc_.createElement("paramList");
	mr_request.appendChild(paramList);

	Element content = doc_.createElement("content");
	mr_request.appendChild(content);

	Element resource_list = doc_.createElement("resourceList");
	Element resource = doc_.createElement("resource");
	resource.setAttribute("name", resource_name);
	resource_list.appendChild(resource);
	content.appendChild(resource_list);

	Element mr_result = (Element)mr_.process(mr_message);

	// add the results to the page
	page.appendChild(doc_.importNode(request, true));
	page.appendChild(doc_.importNode(GSXML.getChildByTagName(mr_result, "response"), true));
	

	String transformed_result = transformer_.transform(stylesheet, page);
							   
    
	return transformed_result;
    }
    

}
